      subroutine c2cal(itrj,mjr,samp,wgt,ampa,mxsi,mxsf,nsrmax)
c----------------------------------------------------------------------
c       ampa(r,theta,j,m,msf,msi,ip,ils,c2-term)
c----------------------------------------------------------------------
C  INPUT
c    itrj   
c    mjr    
c    samp   
c    wgt    
c    mxsi   
c    mxsf   
c    nsrmax 
c    vll    
C  OUTPUT
c    ampa   
c----------------------------------------------------------------------
      include 'dimn.fh'
      include 'drive.fh'
      dimension wgt(*)
      complex ampa(nsrdm,2,2,2,2,6)
      complex samp(nsrdm,njdm,njdm2,2,2,2,2)
      complex d2samp(nsrdm,2,2,2,2)
c
      j1=itrj-1
      j1w=2*j1
      mm1=mjr-j1-1
      mm1w=2*mm1
c
      do 500 ip=1,2
        do 500 ils=1,2
          do 500 msf=1,mxsf
            do 500 msi=1,mxsi
              do 500 n=1,nsrmax
                d2samp(n,msf,msi,ip,ils)=(0.0,0.0)
  500 continue
      do 550 ij2=1,3
        j2=j1+ij2-2
        if(j2.lt.0) go to 550
        j2w=2*j2
        ij21=j2+1
        ip=ij2-(ij2/2)*2+1
        ils=ij2/2+1
        do 540 imm2=1,2
          mm2=mm1-imm2*2+3
          if(abs(mm2).gt.j2) go to 540
          mm2w=2*mm2
          mj2=mm2+j2+1
          muw=mm1w-mm2w
          cl=cleb(j2w,mm2w,2,muw,j1w,mm1w)
          do 530 msf=1,mxsf
            do 520 msi=1,mxsi
              do 510 n=1,nsrmax
                d2samp(n,msf,msi,ip,ils)=d2samp(n,msf,msi,ip,ils)
     1            +sqrt(0.5)*cl*samp(n,ij21,mj2,msf,msi,1,1)
  510         continue
  520       continue
  530     continue
  540   continue
  550 continue
      if(j1.ne.0) then
        do 650 msf=1,mxsf
          do 640 msi=1,mxsi
            do 620 n1=1,nsrmax
              do 610 n2=1,nsrmax
                ampa(n1,msf,msi,2,1,3)
     1                =ampa(n1,msf,msi,2,1,3)
     2                -vll(n1,n2,itrj-1,1,3)
     3                *d2samp(n2,msf,msi,2,1)*wgt(n2)
                ampa(n1,msf,msi,1,2,3)
     1                =ampa(n1,msf,msi,1,2,3)
     2                -vll(n1,n2,itrj,1,3)
     3                *d2samp(n2,msf,msi,1,2)*wgt(n2)
  610         continue
  620       continue
  640     continue
  650   continue
      end if
      do 780 msf=1,mxsf
        do 770 msi=1,mxsi
          do 750 n1=1,nsrmax
            do 740 n2=1,nsrmax
              ampa(n1,msf,msi,2,2,3)
     1            =ampa(n1,msf,msi,2,2,3)
     2            -vll(n1,n2,itrj+1,1,3)
     3            *d2samp(n2,msf,msi,2,2)*wgt(n2)
  740       continue
  750     continue
  770   continue
  780 continue
c
      return
      end
